<!--
  ~ #%L
  ~ chvote-bo
  ~ %%
  ~ Copyright (C) 2016 - 2019 République et Canton de Genève
  ~ %%
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  ~ GNU General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  ~ #L%
  -->

<mat-card id="registerEdit" [class.read-only]="readOnly">
  <mat-card-header>
    <mat-card-title>{{ "voting-material.register.title" | translate }}</mat-card-title>
    <mat-card-subtitle>{{ "voting-material.register.subtitle" | translate }}</mat-card-subtitle>
  </mat-card-header>
  <mat-card-content fxLayout="column" class="no-padding">

    <div class="mat-card-button-toolbar"
         fxLayout fxLayoutAlign="end" fxLayoutGap="2.5rem">
      <ng-container *roles="['GET_REGISTER_REPORT']">
        <button *ngIf="registerCount > 0" id="consolidatedReportButton" mat-button color="primary"
                (click)="getConsolidatedReport()">
          {{"voting-material.register.actions.download-global-report" | translate | uppercase}}
        </button>
      </ng-container>

      <ng-container *roles="['UPLOAD_REGISTER_FILE']">
        <button mat-raised-button (click)="uploadRegister()" color="primary" id="uploadRegister" *ngIf="!readOnly">
          <mat-icon>file_upload</mat-icon>&nbsp;{{"voting-material.register.actions.import" | translate | uppercase}}
        </button>
      </ng-container>
    </div>

    <div [hidden]="registerCount === 0">

      <mat-table #table [dataSource]="dataSource" matSort id="registerFilesTable">
        <ng-container matColumnDef="managementEntity">
          <mat-header-cell *matHeaderCellDef mat-sort-header>
            {{"voting-material.register.grid.header.managementEntity" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element"> {{element.managementEntity}}</mat-cell>
        </ng-container>


        <ng-container matColumnDef="fileName">
          <mat-header-cell *matHeaderCellDef mat-sort-header> {{"voting-material.register.grid.header.file" |
            translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element"> {{element.fileName}}</mat-cell>
        </ng-container>

        <ng-container matColumnDef="uploadDetails">
          <mat-header-cell *matHeaderCellDef> {{"voting-material.register.grid.header.uploadDetails" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            <div>
              <span class="field-title">
                {{"voting-material.register.grid.header.uploader" | translate}} :
              </span>
              <span class="field-value uploader">
              {{element.uploader}}
              </span>
            </div>
            <div>
              <span class="field-title">
                {{"voting-material.register.grid.header.upload-date" | translate}} :
              </span>
              <span class="field-value upload-date">
              {{element.uploadDate | date:'dd.MM.yyyy'}}
              </span>
            </div>
            <div>
              <span class="field-title">
                {{"voting-material.register.grid.header.emitter" | translate}} :
              </span>
              <span class="field-value emitter">
                {{element.emitter}}
              </span>
            </div>
            <div>
              <span class="field-title"> {{"voting-material.register.grid.header.emission-date" | translate}} : </span>
              <span class="field-value emission-date">
              {{element.emissionDate | date:'dd.MM.yyyy'}}
              </span>
            </div>
          </mat-cell>
        </ng-container>

        <ng-container matColumnDef="statistics">
          <mat-header-cell *matHeaderCellDef> {{"voting-material.register.grid.header.statistics" |
            translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            <div>
              <span class="field-title"> {{"voting-material.register.grid.header.voter-count" | translate}} : </span>
              <span class="field-value voter-count">
              {{element.voterCount}}
              </span>
            </div>
            <div>
              <span class="field-title"> {{"voting-material.register.grid.header.doi-count" | translate}} : </span>
              <span class="field-value doi-count">
              {{element.doiCount}}
              </span>
            </div>
            <div>
              <span
                class="field-title"> {{"voting-material.register.grid.header.counting-circle-count" | translate}} : </span>
              <span class="field-value counting-circle-count">
              {{element.countingCircleCount}}
              </span>
            </div>
          </mat-cell>
        </ng-container>
        <ng-container matColumnDef="detailedReport">
          <mat-header-cell *matHeaderCellDef> {{"voting-material.register.grid.header.detailed-report" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            <button mat-icon-button
                    color="primary"
                    (click)="getReport(element.messageUniqueId)">
              <mat-icon>search</mat-icon>
            </button>
          </mat-cell>
        </ng-container>
        <ng-container matColumnDef="delete">
          <mat-header-cell *matHeaderCellDef> {{"voting-material.register.grid.header.delete" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            <button mat-icon-button
                    color="accent"
                    *ngIf="userManagementEntityCanDelete(element)"
                    (click)="remove(element.messageUniqueId, element.fileName)">
              <mat-icon>clear</mat-icon>
            </button>
          </mat-cell>
        </ng-container>

        <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
        <mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>
      </mat-table>
    </div>
  </mat-card-content>
</mat-card>
